'use strict';

const dcl = require('./dcl');

var Stateful = dcl( {
	myFunc: function () { return 1; }
});

var Selection = dcl(Stateful, {
	// set selectionMode(value) {},
	// get selectionMode() {
	// 	return this.myFunc();
	// }
	selectionMode: dcl.prop({
		set: function (value) {
		},
		get: function () {
			return this.myFunc();
		}
	})
});

var Select = dcl(Selection, {
	selectionMode: dcl.prop({
		set: dcl.superCall(function (sup) {
			return function (value) {
				sup.call(this, value);
			};
		}),
		get: dcl.superCall(function (sup) {
			return function () {
				return sup.call(this);
			};
		})
	})
});

const t = new Select();
console.log(t.selectionMode);
